Rivet::FastJets Class Reference

Project out jets found using the FastJet package jet algorithms. More...

`#include <FastJets.hh>`

Inheritance diagram for Rivet::FastJets:

## Public Types

enum | JetAlgName { KT, CAM, SISCONE, ANTIKT, PXCONE, ATLASCONE, CMSCONE, CDFJETCLU, CDFMIDPOINT, D0ILCONE, JADE, DURHAM, TRACKJET }
| Wrapper enum for selected Fastjet jet algorithms.
Public Types inherited from Rivet::JetAlg
typedef Jet | entity_type
typedef Jets | collection_type

## Public Member Functions

void | reset ()
| Reset the projection. Jet def, etc. are unchanged. More...
void | useJetArea (fastjet::AreaDefinition *adef)
| Use provided jet area definition. More...
size_t | numJets (double ptmin=0.0) const
| Number of jets above the cut.
size_t | size () const
| Number of jets.
PseudoJets | pseudoJets (double ptmin=0.0) const
| Get the pseudo jets (unordered).
PseudoJets | pseudoJetsByPt (double ptmin=0.0) const
| Get the pseudo jets, ordered by .
PseudoJets | pseudoJetsByE (double ptmin=0.0) const
| Get the pseudo jets, ordered by .
PseudoJets | pseudoJetsByRapidity (double ptmin=0.0) const
| Get the pseudo jets, ordered by rapidity.
const fastjet::ClusterSequence * | clusterSeq () const
| Return the cluster sequence (FastJet-specific).
const fastjet::ClusterSequenceArea * | clusterSeqArea () const
| Return the cluster sequence (FastJet-specific). More...
const fastjet::JetDefinition & | jetDef () const
| Return the jet definition (FastJet-specific).
const fastjet::AreaDefinition * | areaDef () const
| Return the area definition (FastJet-specific). May be null.
vector< double > | ySubJet (const fastjet::PseudoJet &jet) const
| Get the subjet splitting variables for the given jet.
fastjet::PseudoJet | splitJet (fastjet::PseudoJet jet, double &last_R) const
| Split a jet a la PRL100,242001(2008). Based on code from G.Salam, A.Davison.
fastjet::PseudoJet | filterJet (fastjet::PseudoJet jet, double &stingy_R, const double def_R) const
| Filter a jet a la PRL100,242001(2008). Based on code from G.Salam, A.Davison.
void | calc (const ParticleVector &ps)
| Do the calculation locally (no caching).
Constructors etc.
| FastJets (const FinalState &fsp, JetAlgName alg, double rparameter, double seed_threshold=1.0)
| FastJets (const FinalState &fsp, fastjet::JetAlgorithm type, fastjet::RecombinationScheme recom, double rparameter)
| Native argument constructor, using FastJet alg/scheme enums.
| FastJets (const FinalState &fsp, fastjet::JetDefinition::Plugin *plugin)
| Explicitly pass in an externally-constructed plugin (must be heap-allocated, Rivet will delete)
| FastJets (const FinalState &fsp, fastjet::JetDefinition::Plugin &plugin)
| Explicitly pass in an externally-constructed plugin (must be heap-allocated, Rivet will delete)
| FastJets (JetAlgName alg, double rparameter, double seed_threshold=1.0)
| Same thing as above, but without an FS (for when we want to pass the particles directly to the calc method)
| FastJets (fastjet::JetAlgorithm type, fastjet::RecombinationScheme recom, double rparameter)
| Same thing as above, but without an FS (for when we want to pass the particles directly to the calc method)
| FastJets (fastjet::JetDefinition::Plugin *plugin)
| Same thing as above, but without an FS (for when we want to pass the particles directly to the calc method)
| FastJets (fastjet::JetDefinition::Plugin &plugin)
| Same thing as above, but without an FS (for when we want to pass the particles directly to the calc method)
virtual const Projection * | clone () const
| Clone on the heap.
Public Member Functions inherited from Rivet::JetAlg
| JetAlg (const FinalState &fs)
| Constructor.
virtual | ~JetAlg ()
| Destructor.
void | useInvisibles (bool useinvis=true)

Include invisible particles in jet construction. The default behaviour is that jets are only constructed from visible (i.e. charged under an SM gauge group) particles. Some jet studies, including those from ATLAS, use a definition in which neutrinos from hadron decays are included (via MC correction) in the experimental jet definition. Setting this flag to true avoids the automatic restriction to a VisibleFinalState.

virtual Jets | jets (double ptmin=0.0, double ptmax=MAXDOUBLE, double rapmin=-MAXDOUBLE, double rapmax=MAXDOUBLE, RapScheme rapscheme=PSEUDORAPIDITY) const
template<typename F >
Jets | jets (F sorter, double ptmin, double ptmax, double rapmin, double rapmax, RapScheme rapscheme) const
Jets | jetsByPt (double ptmin=0.0, double ptmax=MAXDOUBLE, double rapmin=-MAXDOUBLE, double rapmax=MAXDOUBLE, RapScheme rapscheme=PSEUDORAPIDITY) const
Jets | jetsByP (double ptmin=0.0, double ptmax=MAXDOUBLE, double rapmin=-MAXDOUBLE, double rapmax=MAXDOUBLE, RapScheme rapscheme=PSEUDORAPIDITY) const
Jets | jetsByE (double ptmin=0.0, double ptmax=MAXDOUBLE, double rapmin=-MAXDOUBLE, double rapmax=MAXDOUBLE, RapScheme rapscheme=PSEUDORAPIDITY) const
Jets | jetsByEt (double ptmin=0.0, double ptmax=MAXDOUBLE, double rapmin=-MAXDOUBLE, double rapmax=MAXDOUBLE, RapScheme rapscheme=PSEUDORAPIDITY) const
collection_type | entities () const
| Template-usable interface common to FinalState.
Public Member Functions inherited from Rivet::Projection
bool | before (const Projection &p) const
virtual const std::set< PdgIdPair > | beamPairs () const
virtual std::string | name () const
| Get the name of the projection.
Projection & | addPdgIdPair (PdgId beam1, PdgId beam2)
| Add a colliding beam pair.
Log & | getLog () const
| Get a Log object based on the getName() property of the calling projection object.
void | setName (const std::string &name)
| Used by derived classes to set their name.
| Projection ()
| The default constructor.
virtual | ~Projection ()
| The destructor.
Public Member Functions inherited from Rivet::ProjectionApplier
| ProjectionApplier ()
| Constructor.
std::set< ConstProjectionPtr > | getProjections () const
| Get the contained projections, including recursion.
template<typename PROJ >
const PROJ & | getProjection (const std::string &name) const
| Get the named projection, specifying return type via a template argument.
const Projection & | getProjection (const std::string &name) const
template<typename PROJ >
const PROJ & | applyProjection (const Event &evt, const PROJ &proj) const
| Apply the supplied projection on event.
template<typename PROJ >
const PROJ & | applyProjection (const Event &evt, const Projection &proj) const
| Apply the supplied projection on event.
template<typename PROJ >
const PROJ & | applyProjection (const Event &evt, const std::string &name) const
| Apply the named projection on event.

## Protected Member Functions

void | project (const Event &e)
| Perform the projection on the Event.
int | compare (const Projection &p) const
| Compare projections.
Protected Member Functions inherited from Rivet::Projection
Cmp< Projection > | mkNamedPCmp (const Projection &otherparent, const std::string &pname) const
Cmp< Projection > | mkPCmp (const Projection &otherparent, const std::string &pname) const
Protected Member Functions inherited from Rivet::ProjectionApplier
Log & | getLog () const
ProjectionHandler & | getProjHandler () const
| Get a reference to the ProjectionHandler for this thread.
template<typename PROJ >
const PROJ & | addProjection (const PROJ &proj, const std::string &name)

## Detailed Description

Project out jets found using the FastJet package jet algorithms.

## Constructor & Destructor Documentation

Rivet::FastJets::FastJets | ( | const FinalState & | fsp,
|  | JetAlgName | alg,
|  | double | rparameter,
|  | double | seed_threshold = `1.0`
| ) |  |

inline

"Wrapped" argument constructor using Rivet enums for most common jet alg choices (including some plugins). For the built-in algs, E-scheme recombination is used. For full control of FastJet built-in jet algs, use the native arg constructor.

Referenced by clone().

## Member Function Documentation

const fastjet::ClusterSequenceArea* Rivet::FastJets::clusterSeqArea | ( |  | ) | const

inline

Return the cluster sequence (FastJet-specific).

Todo:
  Throw error if no area def? Or just blindly call dynamic_cast?

void Rivet::FastJets::reset | ( |  | ) |

virtual

Reset the projection. Jet def, etc. are unchanged.

Todo:
  _cseq = fastjet::ClusterSequence();

Implements Rivet::JetAlg.

void Rivet::FastJets::useJetArea | ( | fastjet::AreaDefinition * | adef | ) |

inline

Use provided jet area definition.

Warning
  adef is NOT copied, the user must ensure that it remains valid! Provide an adef null pointer to re-disable jet area calculation

The documentation for this class was generated from the following files:

- include/Rivet/Projections/FastJets.hh
- src/Projections/FastJets.cc